#include <iostream>
using namespace std;
#include <stdlib.h>

// Bitte hier die Klasse wuerfelTest definieren:

class wuerfelTest {
	private:
		int Wuerfe[7]; // wuerfe[0] ist die Summe
	public:
		// Konstruktor:
		wuerfelTest()
		{
			for(int i = 0; i < 7; i++)
				Wuerfe[i] = 0;
		}

		// Methode zum Speichern eines Wurfes:
		void wurf(int i)
		{
			// Ungueltige Parameterwerte ignorieren:
			if(i < 1)
				return;
			if(i > 6)
				return;

			// Wurf-Anzahl erhoehen:
			Wuerfe[i]++;

			// Gesamt-Anzahl erhoehen:
			Wuerfe[0]++;
		}

		// Methode zur Abfrage der aktuellen Anzahl:
		int anz_wuerfe(int i)
		{
			// Ungueltige Parameterwerte behandeln:
			if(i < 1 || i > 6)
				return -1;

			// Wurf-Anzahl liefern:
			return Wuerfe[i];
		}

		// Methode zur Berechnung von Chi-Quadrat:
		double chi_quadrat()
		{
			// Fall "Keine Daten" behandeln:
			if(Wuerfe[0] == 0)
				return -1;

			// Summe fuer Chi-Quadrat berechnen:
			double summe = 0;
			double normal = Wuerfe[0] / 6.0;
			for(int i = 1; i <= 6; i++) {
				double differenz = Wuerfe[i] - normal;
				summe += differenz * differenz / normal;
			}

			// Berechnete Summe liefern:
			return summe;
		}
};

// Das Hauptprogramm dient zum Testen.
// Es sollte moeglichst nicht veraendert werden.
// Zumindest muss es am Ende wieder genau den gegebenen Programmcode enthalten:

void verify (const char *call, int actual, int desired) {
	if(actual != desired) {
		cout << "Fehler bei " << call << ".\n"
			<< "Soll " << desired << " sein, war aber "
			<< actual << ".\n";
		exit(1);
	}
}

int main()
{
	wuerfelTest a;
	wuerfelTest b;

	// Erster Test: Beispiel aus dem Aufgabenblatt:
	cout << "Erster Test.\n";

	verify ("a.chi_quadrat() vor wurf", a.chi_quadrat(), -1);

	a.wurf(1);
	a.wurf(2);
	a.wurf(1);
	a.wurf(5);
	a.wurf(1);
	a.wurf(5);

	verify ("a.anz_wuerfe(1)", a.anz_wuerfe(1), 3);
	verify ("a.anz_wuerfe(2)", a.anz_wuerfe(2), 1);
	verify ("a.anz_wuerfe(3)", a.anz_wuerfe(3), 0);
	verify ("a.anz_wuerfe(4)", a.anz_wuerfe(4), 0);
	verify ("a.anz_wuerfe(5)", a.anz_wuerfe(5), 2);
	verify ("a.anz_wuerfe(6)", a.anz_wuerfe(6), 0);
	verify ("a.anz_wuerfe(0)", a.anz_wuerfe(0), -1);
	verify ("a.anz_wuerfe(7)", a.anz_wuerfe(7), -1);
	verify ("a.chi_quadrat()", a.chi_quadrat(), 8);


	// Zweiter Test: Viele Wuerfe, perfekt gleichverteilt:
	cout << "Zweiter Test.\n";
	for(int j = 0; j < 1000; j++)
		for(int i = 1; i <= 6; i++)
			b.wurf(i);

	verify ("b.anz_wuerfe(1)", b.anz_wuerfe(1), 1000);
	verify ("b.chi_quadrat()", b.chi_quadrat(), 0);

	// Und nochmal testen, dass sich bei a nichts geaendert hat:
	cout << "Dritter Test.\n";
	verify ("a.anz_wuerfe(1) (nochmal)", a.anz_wuerfe(1), 3);
	verify ("a.chi_quadrat() (nochmal)", a.chi_quadrat(), 8);

	// Ok:
	cout << "\nHerzlichen Glueckwunsch. Alle Tests bestanden.\n";

	// Ende von main:
	return 0;
}

